
include \masm32\include\masm32rt.inc

include \masm32\include\iphlpapi.inc
includelib \masm32\lib\iphlpapi.lib

MIB_TCPSTATS struct
        dwRtoAlgorithm  DWORD ?
        dwRtoMin        DWORD ?
        dwRtoMax        DWORD ?
        dwMaxConn       DWORD ?
        dwActiveOpens   DWORD ?
        dwPassiveOpens  DWORD ?
        dwAttemptFails  DWORD ?
        dwEstabResets   DWORD ?
        dwCurrEstab     DWORD ?
        dwInSegs        DWORD ?
        dwOutSegs       DWORD ?
        dwRetransSegs   DWORD ?
        dwInErrs        DWORD ?
        dwOutRsts       DWORD ?
        dwNumConns      DWORD ?
MIB_TCPSTATS ends

.data

        tcpStats        MIB_TCPSTATS <>

        szTcpTotal      DB "Total # TCP Connections : ",0
        szTcpCap        DB "TCP Stats",0

.code

start:

INVOKE  GetTcpStatistics, OFFSET tcpStats
MOV     ESI, alloc(512)
MOV     EAX, tcpStats.dwNumConns
MOV     EAX, ustr$(EAX)
PUSH    EAX
XOR     EAX, add$(ESI, OFFSET szTcpTotal)
POP     EAX
XOR     EAX, add$(ESI, EAX)
INVOKE  MessageBox, 0, ESI, OFFSET szTcpCap, MB_OK or MB_ICONINFORMATION
INVOKE  ExitProcess, 0

end start